package AO_Grep_Account;

use strict;
use vars qw(@ISA);

use Home_Dirs;
use Mail_Files;

@ISA = ("AO_Template");


# -----------------------------------------------------------------------------

my $menu_string = "\n"
                . "\n User Information"
                . "\n ----------------"
                . "\n "
                . "\n Enter username (blank to quit), <return> : ";

# -----------------------------------------------------------------------------

sub new() {

  my $class     = shift;
  my $devel     = shift;
  my $logs      = shift;
  my $menus     = shift;
  my $yp_passwd = shift;
  my $config    = shift;

    my $self  = { };

    bless($self, $class);

    $self->{MENU_STR} = $menu_string;

    $self->new_AO_template($devel, $logs, $menus, $yp_passwd, $config);

    return $self;
  }

# -----------------------------------------------------------------------------


sub do_it() {

    my $self     = shift;
    my $username = shift;

    $self->do_it_init($username);

    # -------------------------------------------------------------------------
    # -- STANDARD CHECKS :

    my ($one, $two) = $self->do_it_checks($username);
    if ($one) {return $two}


    # -------------------------------------------------------------------------
    # -- MODULE-SPECIFIC STUFF :

    my $base = $username;
        # ...we'll use $base for our grep...

    # -- strip off numbers at end (related accounts are often indicated by
    #    similar string, differences exhibited at numeric end only) :
    $base =~ s/(\d*)$//;

    # -- look in passwd :

    $self->{MENUS}->append_ln();
    $self->{MENUS}->append_b_ln("Looking in passwd space...");
    $self->{MENUS}->append_ln();

    my $matches = $self->{PASSWD}->full_grep_users($base);
    foreach (@$matches) {print "\n $_"}


    # -- look in passwd.adjunct :

    $self->{MENUS}->append_ln();
    $self->{MENUS}->append_b_ln("Looking in passwd.adjunct space...");
    $self->{MENUS}->append_ln();

    my $passwd_adj_pm = $self->{CONFIG}->Passwd_Adj();
    require "$passwd_adj_pm.pm";
    my $passwd_adj = $passwd_adj_pm->new($self->{CONFIG}->passwd_adj());

    my $matches = $passwd_adj->full_grep_users($base);
    foreach (@$matches) {print "\n $_"}


    # -- look in /var/mail :

    $self->{MENUS}->append_ln();
    $self->{MENUS}->append_b_ln("Looking in mail space...");
    $self->{MENUS}->append_ln();

    my $mail = Mail_Files->new("/var/mail");

    foreach (@{$mail->ls_l()}) {
        if ($_ =~ m/$base/) {
            print "\n $_";
          }
      }

    ##############################...use YP_Auto_Home...

    # -- look in home-dirs :

    $self->{MENUS}->append_ln();
    $self->{MENUS}->append_b_ln("Looking in home-dir space...");
    $self->{MENUS}->append_ln();

    my $home_dirs = Home_Dirs->new($self->{CONFIG},$self->{DEVEL});

    foreach (@{$home_dirs->ls_l()}) {
        if ($_ =~ m/$base/) {
            print "\n $_";
          }
      }

    $self->{LOGS}->append("Grepped account ok.");
    $self->{MENUS}->append_ln();
    $self->{MENUS}->message("Done!");

    return "done_it";
  }




# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
