# -----------------------------------------------------------------------------
package Menus_Txt;
# -----------------------------------------------------------------------------

use strict;

# -----------------------------------------------------------------------------

sub new() {

  my $class = shift;
  my $self  = { };

    bless($self, $class);

    return $self;
  }


# -----------------------------------------------------------------------------
# -- MAIN MENU :
# -----------------------------------------------------------------------------

sub put_menu_main() {
    my $self         = shift;
    my $options      = shift;

    my $main_menu = <<EOM;

                     Cosmos Admin Objects Main Menu
                     ------------------------------


                Please choose an option from the list below:-
EOM

    foreach (sort keys %{$options}) {
        $main_menu .= "\n                " . $_ . "    " . $options->{$_}->[1];
      }

    $main_menu .= <<EOM;


                0       Exit

EOM

    $main_menu .= "                Please enter number and <Return> :  ";

    $self->clear();    

    print $main_menu;
  }

# -----------------------------------------------------------------------------
#--

sub get_menu_main_option() {

  my $self    = shift;
  my $options = shift;
  my $option  = <STDIN>;

    chomp($option);

    if ($option eq "0") {
        return "exit";
      }
    elsif (defined $options->{$option}) {
        return $options->{$option}->[0]
      }
    else {
        return "default";
      } 

    return $option;
  }


# -----------------------------------------------------------------------------
# -- MODULE MENU :
# -----------------------------------------------------------------------------

# -- 

sub put_module_main_menu() {

  my $self   = shift;
  my $module = shift;

    $self->clear();
    print $module->txt_menu_str();
  }

# -----------------------------------------------------------------------------
# --

sub get_option() {
    my $self   = shift;
    my $opt    = <STDIN>;
    chomp($opt);
    return $opt;
  }

# -----------------------------------------------------------------------------
# --

sub confirm() {
    my $self = shift;
    my $str  = shift;

    print "\n ";
    print "\n $str [y/n] ";

    my $reply = <STDIN>;
    chomp $reply;

    if (($reply =~ m/^y$/i) || ($reply =~ m/^ye$/i) || ($reply =~ m/^yes$/i)) {
        return 1;
      }
    else {
        return 0;
      }
  }


# -----------------------------------------------------------------------------
# -- TOOLKIT :
# -----------------------------------------------------------------------------


sub clear() {

  my $self   = shift;

    system("/usr/bin/clear");
  }


sub get_field() {
  my $self   = shift;
  my $string = shift;

    print "\n $string <return> :  ";

    my $field = <STDIN>;
    chomp($field);
    return $field;
  }


sub message_clr() {

  my $self   = shift;
  my $string = shift;

    $self->clear();
    $self->message($string);
  } 


sub error_message() {

  my $self   = shift;
  my $string = shift;

    print "\n ";
    print "\n *** ERROR: ";
    print "\n            $string";
    print "\n ";
    print "\n     [<return> to continue...]";
    print "\n ";
    print "\n ";

    my $tmp = <STDIN>;
  } 

sub message() {

  my $self   = shift;
  my $string = shift;

    print "\n ";
    print "\n $string";
    print "\n ";
    print "\n     [<return> to continue...]";
    print "\n ";
    print "\n ";

    my $tmp = <STDIN>;
  } 


sub append() {

  my $self   = shift;
  my $string = shift;

    unless (defined $string) {$string = ""}
    print " $string";
  } 

sub append_ln() {

  my $self   = shift;
  my $string = shift;

    unless (defined $string) {$string = ""}
    print "\n $string";
  } 

sub append_b_ln() {

  my $self   = shift;
  my $string = shift;

    unless (defined $string) {$string = ""}
    print "\n ** $string";
  } 


sub AK_to_Cont_Wait() {

  my $self = shift;
  my $str  = shift;

    if (defined $str) {
        print "\n";
        print "\n $str";
      }

    unless (defined $str) {$str = ""}

    print "\n";
    print "\n     [Any key to continue...]";
    print "\n";
    print "\n";

    my $tmp = <STDIN>;
  }


# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
