# -----------------------------------------------------------------------------
package T_Passwd;
# -----------------------------------------------------------------------------

use strict;

# -----------------------------------------------------------------------------
# -- CONSTRUCTOR :
# -----------------------------------------------------------------------------


# -----------------------------------------------------------------------------
# -- CONSTRUCTOR SLAVES :
# -----------------------------------------------------------------------------

sub get_self() {

  my $self     = shift;
  my $file     = shift;

    my $textline     = "";
    my $i            = 0;
    my $greatest_uid = 1000;
        # ...start with something bigger than 0 in case of error!

    $self->{FILE} = $file;

    open(DATA, "< $file") 
        || die "\n\n Can't open < $file\n\n";

    my ($uname, $uid, $gid, $fullname, $homedir, $shell);

    while ($textline = <DATA>) {

        $textline =~ s/\n//g;
        $textline =~ s/\r//g;

        ($uname,    undef,    $uid, $gid, 
         $fullname, $homedir, $shell) = split(/\:/, $textline);

        $self->{$uname}->{TEXTLINE} = $textline;
        $self->{$uname}->{UID}      = $uid;
        $self->{$uname}->{GID}      = $gid;
        $self->{$uname}->{FULLNAME} = $fullname;
        $self->{$uname}->{HOMEDIR}  = $homedir;
        $self->{$uname}->{SHELL}    = $shell;

        if ($uid > $greatest_uid) {$greatest_uid = $uid}
      }

    close(DATA);

    $self->{GREATEST_UID} = $greatest_uid;

    return $self;
  }


# -----------------------------------------------------------------------------
# -- NEW-ACCOUNT :
# -----------------------------------------------------------------------------

sub new_account_() {
    my ($self, $uname, $uid, $gid, $cname, $shell) = @_;

    $self->{GREATEST_UID} = $self->{GREATEST_UID} + 1;

    $self->{DEVEL}->output($self->{NEW_ACC_STR});

    $self->{$uname}->{TEXTLINE} = $self->{NEW_ACC_STR};
    $self->{$uname}->{UID}      = $uid;
    $self->{$uname}->{GID}      = $gid;
    $self->{$uname}->{FULLNAME} = $cname;
    $self->{$uname}->{HOMEDIR}  = "/home/$uname";
    $self->{$uname}->{SHELL}    = $shell;
  }


sub append_new_acc_() {
    my $self      = shift;
    my $untainted = shift;

    system("/bin/echo $untainted >> " 
         . $self->{CONFIG}->passwd_dir() 
         . "/passwd"); 

#    ...check system call...

    $self->{LOGS}->append_new_acc("Appended to passwd: " 
                                . $self->{NEW_ACC_STR});    
  }


# -----------------------------------------------------------------------------
# -- READ METHODS :
# -----------------------------------------------------------------------------

sub uname() {
    my $self = shift;
    my $uid  = shift;

    my $alt_self = { };

    foreach (keys %$self) {

        $alt_self->{$self->{$_}->{UID}}->{UNAME}    = $_;
        $alt_self->{$self->{$_}->{UID}}->{FULLNAME} = $self->{$_}->{FULLNAME};
        $alt_self->{$self->{$_}->{UID}}->{SHELL}    = $self->{$_}->{SHELL};
        $alt_self->{$self->{$_}->{UID}}->{GID}      = $self->{$_}->{GID};
        $alt_self->{$self->{$_}->{UID}}->{HOMEDIR}  = $self->{$_}->{HOMEDIR};
      }  

    print $uid;
    return $alt_self->{$uid}->{UNAME};
  }

# -----------------------------------------------------------------------------

sub known_user() {
    my $self  = shift;
    my $uname = shift;

    if (defined $self->{$uname}) {
        return 1
      }
    else {
        return 0;
      }
  }

sub uid() {
    my $self  = shift;
    my $uname = shift;

    return $self->{$uname}->{UID};
  }

sub gid() {
    my $self  = shift;
    my $uname = shift;

    return $self->{$uname}->{GID};
  }

sub fullname() {
    my $self  = shift;
    my $uname = shift;

    return $self->{$uname}->{FULLNAME};
  }

sub homedir() {
    my $self  = shift;
    my $uname = shift;

    return $self->{$uname}->{HOMEDIR};
  }

sub shell() {
    my $self  = shift;
    my $uname = shift;

    return $self->{$uname}->{SHELL};
  }

sub users() {
    my $self = shift;

    my @users = keys %$self;

    return \@users;
  }

sub grep_users() {
    my $self = shift;
    my $str  = shift;

    my @users   = keys %$self;
    my @matches = ();

    foreach (@{$self->users()}) {
        if ($_ =~ m/$str/) {
            push(@matches, $_);
          }
      }

    return \@matches;
  }

# -----------------------------------------------------------------------------
# -- SPECIALS :
# -----------------------------------------------------------------------------

# --

sub full_grep_users() {
    my $self = shift;
    my $str  = shift;

    # ...ensure find n copies if such exists...
    # ...ensure find n copies if such exists...

    open(DATA, "< " .$self->{FILE}) 
        || die "\n\n Can't open < " . $self->{FILE} . "\n\n";

    my ($uname, $uid, $gid, $fullname, $homedir, $shell);
    my @matches = ();

    while (my $textline = <DATA>) {

        $textline =~ s/\n//g;
        $textline =~ s/\r//g;

        ($uname,    undef,    $uid, $gid, 
         $fullname, $homedir, $shell) = split(/\:/, $textline);

        if ($uname =~ m/$str/) {
            push(@matches, $uname);
          }
      }
    close(DATA);

    return \@matches;
  }

# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
