# -----------------------------------------------------------------------------
package YP_Sol_Passwd;
# -----------------------------------------------------------------------------

use strict;
use T_Passwd;
use vars qw(@ISA);

@ISA = ("T_Passwd");


# -----------------------------------------------------------------------------
# --

sub new() {

  my $class  = shift;
  my $file   = shift;
  my $config = shift;
  my $devel  = shift;
  my $logs   = shift;

    my $self  = { };

    bless($self, $class);

    $self->{CONFIG} = $config;
    $self->{DEVEL}  = $devel;
    $self->{LOGS}   = $logs;

    $self->get_self($file);

    return $self;
  }


# -----------------------------------------------------------------------------
# -- CONSTRUCTOR SLAVES :
# -----------------------------------------------------------------------------



# -----------------------------------------------------------------------------
# -- NEW-ACCOUNT :
# -----------------------------------------------------------------------------

sub new_account() {
    my $self  = shift;
    my $uname = shift;
    my $cname = shift;

    $self->{DEVEL}->marker("username: $uname");

    my $uid = $self->{GREATEST_UID} + 1;
    my $gid = $self->{CONFIG}->gid($uname);
    my $shell = "/usr/local/bin/bash";

    $self->{NEW_ACC_STR} = $uname . ":##" . $uname . ":" 
                         . $uid . ":" . $gid . ":" 
                         . $cname . ":/home/" . $uname 
                         . ":" . $shell;

    $self->new_account_($uname, $uid, $gid, $cname, $shell);

    return (1, $uid, $gid);
  }


sub append_new_acc() {
    my $self  = shift;
    my $uname = shift;

    $self->{DEVEL}->marker("username: $uname");

    my $untainted = $self->{NEW_ACC_STR};

    unless ($untainted =~ m/^(
                            [a-zA-Z0-9]+:\#\#[a-zA-Z0-9]+:  # uname...
                            [0-9]+:[0-9]+:                  # uid:gid
                            [a-zA-Z\.\-\s]+:                # common name
                            \/home\/m[a-z0-9]+:             # home dir
                            \/usr\/local\/bin\/bash         # bash!
                            \s*)$
                            /x) {
        $self->{DEVEL}->die("Tainted: //$untainted//");
      }
    $untainted = $1;

    $self->append_new_acc_($untainted);
  }

# -----------------------------------------------------------------------------
# -- READ METHODS :
# -----------------------------------------------------------------------------

# -----------------------------------------------------------------------------
1;
# -----------------------------------------------------------------------------
